namespace eval psp_genbus_lib {
################################################################################
# General functions

	# takes connection list as passed to GenerateBUS (hw) or GenerateLib (sw) and 
	#  turn it into a list of key-value pairs
	proc createConKV { hw_or_sw connections } {
		set keyValConnectionList [list]
		
		foreach con $connections {
			if {$hw_or_sw == "hw"} {
				# called from GenerateBUS 
			set conList "type=[lindex $con 0]"
			if { [lindex $con 0] == "memory" } {
				lappend conList "name=[lindex $con 1]"
				lappend conList "busName=[lindex $con 2]"
				lappend conList "busType=[lindex $con 3]"
			} else {
				lappend conList "dir=[lindex $con 1]"
				lappend conList "name=[lindex $con 2]"
				lappend conList "width=[lindex $con 3]"
				lappend conList "busName=[lindex $con 4]"
				lappend conList "busType=[lindex $con 5]"
   			}
			} else {
				# called from GenerateLib
				set conList "type=[lindex $con 0]"
				if { [lindex $con 0] == "memory" } {
					lappend conList "dst=[lindex $con 1]"
					lappend conList "loc=[lindex $con 2]"
				} else {
					lappend conList "dir=[lindex $con 1]"
					lappend conList "name=[lindex $con 2]"
					lappend conList "varname=[lindex $con 3]"
					lappend conList "width=[lindex $con 4]"
					lappend conList "loc=[lindex $con 5]"
				}				
			}
			puts "conList=$conList"
			lappend keyValConnectionList $conList
		}
		#puts "keyValConnectionList=$keyValConnectionList"
		return $keyValConnectionList
	}

	
	# get a connection by name returning a list of key-value pairs for it
	# conKV is a list of key=val pairs as created using createConKV()
	proc getConByName { conKV conName } {
		# TODO
		puts "TODO:getConByName { conKV conName }"
		exit -1;
	}
	
	# conKV is a list of key=val pairs as created using createConKV() 
	proc getConField { conKV fieldName } {
		#puts "getConField($con,$fieldName)"
		set fieldStr [lindex $conKV [lsearch $conKV "$fieldName=*"]]
		#puts "getConField():fieldStr=$fieldStr"
		set fieldVal [string range $fieldStr [expr [string first = $fieldStr] + 1] end]
		#puts "getConField():fieldVal=$fieldVal"
		return $fieldVal
	}
	
	proc getFilesInDirectory {dirname filter} {
		# craeate list of all generated PSP impulse lib files in hw/lib
		set fileList [list]
		foreach f [glob -nocomplain -type f $dirname/$filter] {
			lappend fileList [file tail $f] 
		}
		return $fileList
	}
	
	# generic enough to be here?
	proc getExportedHwLibFiles {pspHdlBaseDir exportLibDir} {
		# craeate list of all exported PSP impulse lib files
		set expHwLibFiles [getFilesInDirectory [file join $pspHdlBaseDir $exportLibDir] "*"]
		return $expHwLibFiles
	}
	proc getGeneratedHwFiles {outdir} {
		# create list of all PSP generated HDL files in "hw"
		# kind of kludgey, '_top and '_comp are not necesarily in the dir yet, but userip 
		#  has been copied already
		#  global hdlfiles has the names of the '_top and '_comp files
		#  global tmpname appears to have the temporary file name for '_top that is open
		global hdlfiles
		global tmpname	
		set ignoreName [file tail $tmpname]
		set hwFiles [getFilesInDirectory $outdir "*"]
		set hwFiles [concat $hdlfiles $hwFiles]
		
		set tmpnameIdx [lsearch $hwFiles $ignoreName]
		if { $tmpnameIdx >= 0 } {
			set hwFiles [lreplace $hwFiles $tmpnameIdx $tmpnameIdx]
		}
		return [lsort -unique $hwFiles]
	}
	
	proc getGeneratedHwLibFiles {outdir} {
		# create list of all generated PSP impulse lib files in hw/lib
		set hwLibFiles [getFilesInDirectory [file join $outdir lib] "*"]
		return $hwLibFiles
	}
	
}	;# end of namespace psp_genbus_lib

# successful return code for source'ing of this file
return 0
