#####
# CORE Generator 
#####
namespace eval ::xilinx::coregen {
	
	proc generateCoreFromXco {dir cgpFileName xcoFileName } {
		set oldDir [pwd]
		puts "coregen.tcl::generateCoreFromXco():Changing to directory $dir"
		cd $dir
		puts "coregen.tcl::generateCoreFromXco():Running CORE Generator for file project file $cgpFileName and XCO file $xcoFileName"
		set coregenLogFileName "[file rootname $xcoFileName]_coregen.log"
		puts "coregen.tcl::generateCoreFromXco():See $dir/$coregenLogFileName for CORE Generator output"
		puts "coregen.tcl::generateCoreFromXco():NOTE:This may take several minutes to complete..."
		set coregenCmd [list coregen -p $cgpFileName -b $xcoFileName >& $coregenLogFileName]
		puts "Executing $coregenCmd"
		if { [catch [ eval exec $coregenCmd] ] } {
			puts "coregen.tcl::generateCoreFromXco():CORE Generator completed successfully"
			exit -1
		}
		puts "coregen.tcl::generateCoreFromXco():"
		puts "coregen.tcl::generateCoreFromXco():Returning to directory $oldDir"
		cd $oldDir
	}
}

return 0